#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <sys/stat.h>

#define SLASH '/'
#define ADJUST '%'

#define MAXUNIQFILES 20000


typedef struct
{
   char **name;
   int num;
} FILELIST;



#ifdef TEST
main()
{
   FILELIST *list;
   int n, ok;
   char buf[100], dirname[100], fmask[100], dstdir[100], dstname[100];

   do
   {
      printf("Indtast filmaske: ");
      gets(buf);

      fname_split(buf, dirname, fmask);
      printf("DIR = <%s>\nNAME = <%s>\n", dirname, fmask);

      if ((list=fname_expandmask(buf)) != NULL)
      {
	 printf("Indtast destinations maske: ");
	 gets(buf);
	 fname_split(buf, dstdir, dstname);

	 for (n=0 ; n<list->num ; n++)
	 {
	    printf("   %s%s -> ", dirname, list->name[n]);
	    fname_subst(list->name[n], dstname, buf);
	    ok = fname_unique(dirname, buf);
	    printf(" %s%s (%s)\n", dstdir, buf, ok ? "ok" : "-");
	 }
	 fname_freelist(list);
      }
      else
	 printf("Ingen filer ...\n");
   }
   while (buf[0] != 0);
}
#endif


fname_split(buf, dir, name)
char *buf, *dir, *name;
{
   int n, p=0, sp;

   p = strlen(buf) - 1;

      /* Find filename */
   while (p>=0  &&  buf[p] != SLASH)
      p--;
   sp = p;

   for (n=0 ; n<=sp ; n++)
      dir[n] = buf[n];
   dir[n] = 0;

   for (n=sp+1 ; buf[n]!=0 ; n++)
      name[n-sp-1] = buf[n];
   name[n-sp-1] = 0;

   if (buf[0] == 0)
      return(0);

   return(1);
}


fname_match(str, mask)
char *str, *mask;
{
   char *s, *m, f;
   int ok=1, more, match, inverse;

   s = str;
   m = mask;

   do
   {
      if (*m!='*'  &&  *m!='?'  &&  *m!='[')
      {
	 if (*s != *m)
	    return(0);
	 else
	 {
	    if (*s == 0)
	       return(1);
	    s++;
	    m++;
	 }
      }
      else
      if (*m == '?')
      {
	 m++;
	 if (*s == 0)
	    return(0);
	 s++;
      }
      else
      if (*m == '[')
      {
	 m++;
	 if (*m == '!')
	 {
	    inverse = 1;
	    m++;
	 }
	 else
	    inverse = 0;

	 match = 0;
	 f = 0;
	 while (*m != ']'  &&  *m != 0)
	 {
	    if (*m == '-')
	    {
	       m++;
	       if (*m != 0  &&  *m != ']')
	       {
		  if (*s>=f  &&  *s<=*m  &&  !match)
		  {
		     match = 1;
		     s++;
		  }
		  m++;
	       }
	    }
	    else
	       f = *m;

	    if (*s == *m  &&  !match)
	    {
	       match = 1;
	       s++;
	    }

	    if (*m != 0  &&  *m != ']')
	       m++;
	 }
	 if (*m == ']')
	    m++;
	 if (!match && !inverse  ||  match && inverse)
	    return(0);
      }
      else
      if (*m == '*')
      {
	 m++;
	 more = 1;
	 do
	 {
	    while (*s != *m  &&  *s != 0)
	       s++;
	    if (*s == 0)
	       more = 0;
	    else
	    {
	       if (fname_match(s,m))
		  return(1);
	       s++;
	    }
	 }
	 while (more);
      }
      if (*s == 0  &&  *m == 0)
	 return(1);
   }
   while (ok);

   return(1);
}


fname_subst(src, mask, dst)
char *src, *mask, *dst;
{
   char *s, *m, *d;

   s = src;
   m = mask;
   d = dst;

   while (*m != 0)
   {
      if (*s==*m  &&  *m!='*'  &&  *m!='?'  &&  *m!=0)
      {
	 *d = *s;
	 s++;
	 d++;
	 m++;
      }
      else
      if (*m == '*')
      {
	 m++;
	 while (*s!=0  &&  *s!=*m)
	 {
	    *d = *s;
	    s++;
	    d++;
	 }
      }
      else
      if (*m == '?'  &&  *s!=0)
      {
	 m++;
	 *d = *s;
	 d++;
	 s++;
      }
      else
      {
	 *d = *m;
	 d++;
	 m++;
      }
   }

   *d = 0;
   return(1);
}


fname_unique(dir, fname)
char *dir, *fname;
{
   char tmp[10], *old;
   int cou=0, more=1, ok, num;
   int len, n, p;

   if ((len=strlen(fname)-1) <= 0)
      return(0);

   old = strdup(fname);

   do
   {
      sprintf(tmp, "%09d", cou);
      strcpy(fname, old);
      for (n=8, p=len, num=1  ;  p>=0  ;  p--)
      {
	 if (fname[p] == '%')
	 {
	    num = num * 10;
	    fname[p] = tmp[n];
	    if (n>0)
	       n--;
	 }
      }

      if (fname_is_unique(dir, fname))
      {
	 more = 0;
	 ok = 1;
      }
      else
      if (num == 1)
      {
	 more = 0;
	 ok = 0;
      }
      else
      {
	 cou++;
	 if (cou==MAXUNIQFILES  ||  cou%num != cou)
	 {
	    more = 0;
	    ok = 0;
	 }
      }
   }
   while (more);

   free(old);
   return(ok);
}


fname_is_unique(dir, name)
char *dir, *name;
{
   char fname[200];
   struct stat sb;

   sprintf(fname, "%s%s", dir, name);
   if (stat(fname, &sb) == 0)
      return(0);

   return(1);
}
